;
; MSX2TI83 v1.1
;-=============-
;
; Part of the TI-83 Developers Pack for MSX.
;
; This program converts files in the MSX .COM-format to the TI-83 .83P-format.
; It asks if it has to convert in Squished format or in standard TI-ASM format.
; You can force squishing with the option /S, and you can force TI-ASM with the
; option /T. Use /U to make an unprotected file.
;
; Mind you, this does not convert MSX-programs to the TI-83!!!
;
;
; Code written and assembled in CTNG's Compass #1.2.09
;
;(c) 1999  Grauw / Datax
;
;
;
	org	#100
;
Bdos:	equ	5
FCB1:	equ	#5C
MAXSIZE:	equ	27136	;Max. size (about 27k)...
COMMANDLINE:	equ	#80
;
;
Start:	ld	(save_SP),sp
	ld	de,INTROTEXT
	ld	c,9
	call	Bdos

	ld	de,HOW_TO
	ld	c,9
	ld	a,(FCB1+1)
	cp	" "
	jp	z,Bdos

	ld	hl,COMMANDLINE	;Scan for command-line options.
	ld	a,(hl)
	ld	b,a
	inc	hl
ScanComlLoop:	ld	a,(hl)
	inc	hl
	cp	"/"
	jp	z,Coml_Option
	djnz	ScanComlLoop

;
	ld	de,TYPE_QUERY	;Command-line options not found.
	ld	c,9	;Ask for the desired filetype.
	call	Bdos
WaitForKey_I:	ld	c,7
	call	Bdos
	or	32
	cp	"s"
	jp	z,Do_Squish
	cp	"t"
	jp	z,Do_TIASM
	jp	WaitForKey_I

;
Coml_Option:	ld	a,(hl)	;Check which command-line option is given
	or	32
	cp	"s"
	jp	z,Do_Squish
	cp	"t"
	jp	z,Do_TIASM
	cp	"u"
	jp	z,Dont_Protect
	ld	de,HOW_TO
	ld	c,9	;If invalid command-line option, give
	jp	Bdos	; instructions...

;
Dont_Protect:	ld	a,5
	ld	(DATATYPE),a
	jp	ScanComlLoop

;
Do_Squish:	ld	de,FORM_SQUISH	;The user chose "Squish"...
	ld	c,9
	call	Bdos
	jp	Do_FileLoad
;
Do_TIASM:	ld	de,FORM_TIASM	;The user chose "TI-ASM"...
	ld	c,9
	call	Bdos
	ld	a,2
	ld	(FILETYPE),a

;
Do_FileLoad:	ld	a,(FCB1+9)	;If file has no extension then add .COM
	cp	" "
	jp	nz,DontAdd_COM
	ld	a,"C"
	ld	(FCB1+9),a
	ld	a,"O"
	ld	(FCB1+10),a
	ld	a,"M"
	ld	(FCB1+11),a
DontAdd_COM:	ld	de,DATA_83P	;Set DTA
	ld	c,26
	call	Bdos
	ld	de,FCB1	;Open file
	ld	c,15
	call	Bdos
	and	a
	jp	nz,ErrFileName
	ld	hl,(FCB1+16+2)	;filelength
	ld	a,h	;Check if filelength isn't too long...
	or	l
	jp	nz,ErrFileSize
	ld	hl,(FCB1+16)	;filelength
	ld	de,MAXSIZE
	sbc	hl,de
	jp	nc,ErrFileSize
	ld	hl,0	;Set FCB variables right...
	ld	(FCB1+33),hl
	ld	(FCB1+33+2),hl	;recordnr.
	inc	hl
	ld	(FCB1+14),hl	;recordlength
	ld	de,FCB1
	ld	hl,(FCB1+16)	;filelength
	ld	c,39
	call	Bdos
	and	a
	jp	nz,ErrDisk
	ld	de,FCB1	;Close file
	ld	c,16
	call	Bdos
	and	a
	jp	nz,ErrDisk
	ld	hl,(FCB1+16)	;filelength
	ld	(PROGLEN),hl
	inc	hl
	inc	hl	;Calculate several SIZE-entries...
	ld	(DATALEN_HDR),hl
	ld	(DATALEN),hl
;
	ld	a,(FILETYPE)	;If selected filetype is TI-ASM then
	cp	2	; convert current code to that format.
	call	z,Conv_TIASM
;
	ld	hl,(DATALEN)	;Calculate total datasize
	ld	de,11+2+2	;VAR-header + 2 length words
	add	hl,de
	ld	(SIZE_HDRDATA),hl
	ld	hl,FCB1+1
	ld	de,VARNAME
	ld	b,8	;This routine copies the filename
VarNameLoop:	ld	a,(hl)	; to the VAR-name.
	inc	hl
	cp	" "
	jp	nz,VarNameCont
	xor	a
VarNameCont:	ld	(de),a
	inc	de
	djnz	VarNameLoop
	ld	a,"8"
	ld	(FCB1+9),a
	ld	a,"3"
	ld	(FCB1+10),a
	ld	a,"P"
	ld	(FCB1+11),a
	ld	hl,VARHDR_SIZE
	ld	bc,(SIZE_HDRDATA)
	call	Make_Chksum	;Make checksum...
	ld	(hl),e
	inc	hl
	ld	(hl),d
;
	ld	de,FILEHEADER
	ld	c,26	;Set DTA
	call	Bdos
	ld	de,FCB1
	ld	c,22	;Create file
	call	Bdos
	and	a
	jp	nz,ErrDisk
	ld	hl,0	;Set FCB variables right...
	ld	(FCB1+33),hl
	ld	(FCB1+33+2),hl	;recordnr.
	inc	hl
	ld	(FCB1+14),hl	;recordlength
	ld	de,FCB1
	ld	hl,(SIZE_HDRDATA)
	ld	bc,53+2+2	;Add fileheader + datalength + checksum
	add	hl,bc
	ld	c,38	;Write fileheader
	call	Bdos
	and	a
	jp	nz,ErrDisk
	ld	de,FCB1
	ld	c,16	;Close file...
	call	Bdos
	and	a
	jp	nz,ErrDisk
;
	ld	de,CONV_SUCCESS
	ld	c,9	;Notify user of success and end
	jp	Bdos


;
;This routine converts plain hex data to TI's ASM format.
;
Conv_TIASM:	ld	hl,DATA_83P	;Move progdata to upper memory...
	ld	bc,(PROGLEN)
	add	hl,bc
	dec	hl
	ld	de,#BFFF
	lddr
	inc	de
	ex	de,hl	;Startadress data in HL.
	ld	de,DATA_83P	;Destination in DE.
	exx
	ld	b,0
	exx
C_TIASM_Loop:	ld	a,(hl)
	and	#F0
	rrca
	rrca
	rrca
	rrca
	exx
	ld	hl,HEXNUMBERS
	ld	c,a
	add	hl,bc
	ld	a,(hl)
	exx
	ld	(de),a
	inc	de
	ld	a,(hl)
	inc	hl
	and	#0F
	exx
	ld	hl,HEXNUMBERS
	ld	c,a
	add	hl,bc
	ld	a,(hl)
	exx
	ld	(de),a
	inc	de
	ld	a,h
	cp	#C0
	jp	c,C_TIASM_Loop
	ex	de,hl	;Not logical (DE=DEstination), but faster
	ld	(hl),#3F	;tEnter
	inc	hl
	ld	(hl),#D4	;End
	inc	hl
	ld	(hl),#3F	;tEnter
	inc	hl
	ld	(hl),"0"	;0000
	inc	hl
	ld	(hl),"0"
	inc	hl
	ld	(hl),"0"
	inc	hl
	ld	(hl),"0"
	inc	hl
	ld	(hl),#3F	;tEnter
	inc	hl
	ld	(hl),#D4	;End
	ld	hl,(PROGLEN)
	add	hl,hl
	ld	bc,9	;8 extra bytes (^^^ see above ^^^)
	add	hl,bc
	ld	(PROGLEN),hl
	inc	hl
	inc	hl
	ld	(DATALEN_HDR),hl
	ld	(DATALEN),hl
	ret


HEXNUMBERS:	DB	"0123456789ABCDEF"


;
;This routine generates a checksum for the area from HL to HL+BC,
;Result: DE=Generated checksum, HL=updated pointer
;
Make_Chksum:	dec	bc
	inc	b
	inc	c	;Preloop-sequence for fast loop...
	ld	a,c
	ld	c,b
	ld	b,a
	ld	de,0
MakeChk_Loop:	ld	a,e
	add	a,(hl)	;ADD  DE,(HL)
	inc	hl
	ld	e,a
	ld	a,d
	adc	a,0
	ld	d,a
	djnz	MakeChk_Loop
	dec	c
	jp	nz,MakeChk_Loop
	ret


;
;==============================================================================
;= Other routines =============================================================
;==============================================================================
;
;Error routines...
;
ErrFileName:	ld	de,ERR_FNFOUND	;File not found
	ld	c,9
	call	Bdos
	ld	sp,(save_SP)
	ret

ErrDisk:	ld	de,ERR_DISK	;Disk-error
	ld	c,9
	call	Bdos
	ld	sp,(save_SP)
	ret

ErrFileSize:	ld	de,ERR_SIZE	;Disk-error
	ld	c,9
	call	Bdos
	ld	sp,(save_SP)
	ret


;
;==============================================================================
;= Data =======================================================================
;==============================================================================
;
;Data's...
;
save_SP:	DW	0	;Stack Pointer save-adress...
FILETYPE:	DB	1

;
;Text
;
INTROTEXT:	DB	"***********============***********",13,10
	DB	"******=   MSX83-Dev v1.1   =******",13,10
	DB	"********==================********",13,10
	DB	"Hex code to TI-83 .83P converter",13,10
	DB	"(c) 1999  Grauw / Datax",13,10,10,"$"
TYPE_QUERY:	DB	"What filetype do you want, (S)quish or (T)I-ASM???",13,10,10,"$"
FORM_SQUISH:	DB	"Converting using the Squish-format...",13,10,"$"
FORM_TIASM:	DB	"Converting using the TI-ASM format...",13,10,"$"
CONV_SUCCESS:	DB	"Conversion successful!!!",13,10,10,"$"
ERR_DISK:	DB	7,"*** Disk error",13,10,"$"
ERR_FNFOUND:	DB	7,"*** File not found",13,10,"$"
ERR_SIZE:	DB	7,"*** File too long",13,10,"$"

HOW_TO:	DB	"Syntax: MSX83DEV <filename> [/S | /T] [/U]",13,10,10
	DB	"  <filename>: If no extension, .COM will automatically be added.",13,10
	DB	"          /S: Use Squished fileformat",13,10
	DB	"          /T: Use the TI-ASM fileformat",13,10
	DB	"          /U: Disable protection",13,10,10,"$"

;
;.83?-fileformat strings...
;
FILEHEADER:	DB	"**TI83**",26,10,0
	DB	"File generated by MSX83DEV - (c)1999 Grauw"
SIZE_HDRDATA:	DW	0	;Size of header + data
	;Start of VAR-header...
VARHDR_SIZE:	DW	11	;Size of header
DATALEN_HDR:	DW	0	;Length of data
DATATYPE:	DB	6	;Program type (6=protected)
VARNAME:	DS	8,0	;Program name
	;Start of data...
DATALEN:	DW	0	;Length of data
PROGLEN:	DW	0	;Length of program (L-O-Data - 2)
DATA_83P:	;The data!!!
;
;
;
;             DW      0
;          ...Checksum (2 bytes)...


Einde:
;
;

